#!/bin/sh

# Copyright (C) 2022  Braiins Systems s.r.o.
#
# This file is part of Braiins Open-Source Initiative (BOSI).
#
# BOSI is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
#
# Please, keep in mind that we may also license BOSI or any part thereof
# under a proprietary license. For more information on the terms and conditions
# of such proprietary license or if you have any other questions, please
# contact us at opensource@braiins.com.

# Define installation and sysupgrade files
BOS_ENV_FILE=nand_env
BOS_UBOOT_FILE=u-boot.bin
BOS_DTB_FILE=dtb
BOS_KERNEL_FILE=uImage
BOS_ROOTFS_FILE=rootfs.img
BOS_TOOLS_NAME=bos-tools

# name of directory with stock configurations
BOS_ENV_STOCK_CONFIG="stock_config"

# Define file for log of BOS installation
INSTALL_LOG="/config/install.log"

# Temporary files that needs to be writable on both systems stock and BOS:
NAND_ENV_STOCK_FILE=/tmp/nand_env_stock
ENV_TAR=/tmp/env.tar
POST_INSTALL_TAR=/tmp/ro-post_install.tar

# Post install direstory and file
POST_INSTALL_DIR="post_install"
POST_INSTALL_SCRIPT="run.sh"

# Define backup global offsets of bos universal mtd partitions
GLOBAL_BOS_UBOOT_OFFSET=0x000002800000
GLOBAL_BOS_DTB_OFFSET=0x000002c00000
GLOBAL_BOS_KERNEL_OFFSET=0x000002e00000
GLOBAL_BOS_ENV_OFFSET=0x000003800000
GLOBAL_BOS_OVERLAY_OFFSET=0x000004800000
GLOBAL_BOS_ROOTFS_OFFSET=0x000005800000

# Define global and local offsets for BOS ENV partition regions
LOCAL_RO_ENV_TAR_LENGTH_OFFSET_BOS_LAYOUT=0x000000000000
GLOBAL_RO_ENV_TAR_LENGTH_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_RO_ENV_TAR_LENGTH_OFFSET_BOS_LAYOUT)))
LOCAL_RO_ENV_TAR_OFFSET_BOS_LAYOUT=0x000000010000
GLOBAL_RO_ENV_TAR_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_RO_ENV_TAR_OFFSET_BOS_LAYOUT)))
LOCAL_BACKUP_NAND_ENV_OFFSET_BOS_LAYOUT=0x000000E00000
GLOBAL_RO_NAND_ENV_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_BACKUP_NAND_ENV_OFFSET_BOS_LAYOUT)))
LOCAL_RECOVERY_FLAGS_OFFSET_BOS_LAYOUT=0x000000F00000
GLOBAL_RW_FLAGS_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_RECOVERY_FLAGS_OFFSET_BOS_LAYOUT)))

LOCAL_RO_POST_INSTALL_TAR_LENGTH_OFFSET_BOS_LAYOUT=0x000000400000
GLOBAL_RO_POST_INSTALL_TAR_LENGTH_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_RO_POST_INSTALL_TAR_LENGTH_OFFSET_BOS_LAYOUT)))
LOCAL_RO_POST_INSTALL_TAR_OFFSET_BOS_LAYOUT=0x000000410000
GLOBAL_RO_POST_INSTALL_TAR_OFFSET=$(printf "0x%X" $(($GLOBAL_BOS_ENV_OFFSET + $LOCAL_RO_POST_INSTALL_TAR_OFFSET_BOS_LAYOUT)))
POST_INSTALL_TAR_MAX_DECIMAL_SIZE=10420224
# Erase block size is 128.0 KiB and size of post-install nand space is 10 MiB
# so we delete 80 blocks after post-install is executed
POST_INSTALL_TAR_BLOCK_COUNT=80

# Define U-Boot ENV image size
STOCK_ENV_LENGTH=131072

# BOS NAND layout stock U-Boot env partition name
BOS_STOCK_UBOOT_ENV_MTD_NAME="stock_bootenv"

# BOS NAND layout stock `config` partition name
BOS_STOCK_CONFIG_MTD_NAME="stock_config"

# BOS NAND layout BOS U-Boot partition name
BOS_UBOOT_MTD_NAME="uboot"

# BOS NAND layout BOS DTB partition name
BOS_DTB_MTD_NAME="dtb"

# BOS NAND layout BOS kernel partition name
BOS_KERNEL_MTD_NAME="kernel"

# BOS NAND layout BOS ENV partition name
BOS_ENV_MTD_NAME="env"

#BOS NAND layout BOS overlay RW partition name
BOS_OVERLAY_MTD_NAME="overlay"

#BOS NAND layout BOS rootfs partition name
BOS_ROOTFS_MTD_NAME="rootfs"

# Write flag for recovery detection, numbers meaning:
# 1 - After installation of BOS before boot
RECOVERY_FLAG_INSTALLED=0x1

# 2 - First running of uboot, before try to boot BOS
RECOVERY_FLAG_FIRST_BOOT=0x2

# 3 - After successful boot of BOS
RECOVERY_FLAG_SUCCESSFUL=0x3

